/*

					Logic Scope AVR

			Copyrights 2009,  Yoshi Hiroshi


*/

/*
--------------------------------------------------
*/
void normalLog();
// 200 Clock Cycle		10uS
void Log_200_Cycle();
// 100 Clock Cycle		5uS
void Log_100_Cycle();
// 40 Clock Cycle		2uS
void Log_40_Cycle();
// 20 Clock Cycle		1uS
void Log_20_Cycle();
// 10 Clock Cycle		0.5uS
void Log_10_Cycle();
// 4 Clock Cycle		200nS/250nS
void Log_4_Cycle();
#if defined (__AVR_ATmega644P__)
// 3 Clock Cycle		150nS
void Log_3_Cycle();
#endif


/*
--------------------------------------------------
*/
#define LOG_DATA_1_BYTE_3_CYCLE(ptr)	asm volatile("in __tmp_reg__,%2\n\tST Z+,__tmp_reg__":"=z"(ptr):"0"(ptr),"I"(_SFR_IO_ADDR(LOGDATA_PIN)))
#define LOG_DATA_1_BYTE_4_CYCLE(ptr)	asm volatile("in __tmp_reg__,%2\n\tST Z+,__tmp_reg__\n\tnop":"=z"(ptr):"0"(ptr),"I"(_SFR_IO_ADDR(LOGDATA_PIN)))

#define LOG_WAIT_3n_CYCLE(n)			asm volatile("ldi r24, %0\n\t" "1:dec r24\n\t" "brne 1b"::"M"(n));
#define LOG_WAIT_1_CYCLE				asm volatile("nop")
#define LOG_WAIT_2_CYCLE				LOG_WAIT_1_CYCLE;LOG_WAIT_1_CYCLE
#define LOG_WAIT_3_CYCLE				LOG_WAIT_3n_CYCLE(1)
#define LOG_WAIT_4_CYCLE				LOG_WAIT_3n_CYCLE(1); LOG_WAIT_1_CYCLE
#define LOG_WAIT_5_CYCLE				LOG_WAIT_3n_CYCLE(1); LOG_WAIT_2_CYCLE
#define LOG_WAIT_6_CYCLE				LOG_WAIT_3n_CYCLE(2)
#define LOG_WAIT_7_CYCLE				LOG_WAIT_3n_CYCLE(2); LOG_WAIT_1_CYCLE
#define LOG_WAIT_8_CYCLE				LOG_WAIT_3n_CYCLE(2); LOG_WAIT_2_CYCLE
#define LOG_WAIT_13_CYCLE				LOG_WAIT_3n_CYCLE(4); LOG_WAIT_1_CYCLE
#define LOG_WAIT_14_CYCLE				LOG_WAIT_3n_CYCLE(4); LOG_WAIT_2_CYCLE
#define LOG_WAIT_18_CYCLE				LOG_WAIT_3n_CYCLE(6)
#define LOG_WAIT_26_CYCLE				LOG_WAIT_3n_CYCLE(8); LOG_WAIT_2_CYCLE
#define LOG_WAIT_40_CYCLE				LOG_WAIT_3n_CYCLE(13);LOG_WAIT_1_CYCLE
#define LOG_WAIT_53_CYCLE				LOG_WAIT_3n_CYCLE(17);LOG_WAIT_2_CYCLE
#define LOG_WAIT_65_CYCLE				LOG_WAIT_3n_CYCLE(21);LOG_WAIT_2_CYCLE
#define LOG_WAIT_74_CYCLE				LOG_WAIT_3n_CYCLE(24);LOG_WAIT_2_CYCLE
#define LOG_WAIT_86_CYCLE				LOG_WAIT_3n_CYCLE(28);LOG_WAIT_2_CYCLE
#define LOG_WAIT_133_CYCLE				LOG_WAIT_3n_CYCLE(44);LOG_WAIT_1_CYCLE
#define LOG_WAIT_145_CYCLE				LOG_WAIT_3n_CYCLE(48);LOG_WAIT_1_CYCLE
#define LOG_WAIT_174_CYCLE				LOG_WAIT_3n_CYCLE(58)
#define LOG_WAIT_186_CYCLE				LOG_WAIT_3n_CYCLE(62)

////////////////////////////////////////////////////////////

//**********************************************************
//			Fastest Logging Function
//**********************************************************

#define LOG_DATA_2_BYTE_3(ptr)			LOG_DATA_1_BYTE_3_CYCLE(ptr);  LOG_DATA_1_BYTE_3_CYCLE(ptr)
#define LOG_DATA_4_BYTE_3(ptr)			LOG_DATA_2_BYTE_3(ptr);  LOG_DATA_2_BYTE_3(ptr)
#define LOG_DATA_8_BYTE_3(ptr)			LOG_DATA_4_BYTE_3(ptr);  LOG_DATA_4_BYTE_3(ptr)
#define LOG_DATA_16_BYTE_3(ptr)			LOG_DATA_8_BYTE_3(ptr);  LOG_DATA_8_BYTE_3(ptr)
#define LOG_DATA_32_BYTE_3(ptr)			LOG_DATA_16_BYTE_3(ptr); LOG_DATA_16_BYTE_3(ptr)
#define LOG_DATA_64_BYTE_3(ptr)			LOG_DATA_32_BYTE_3(ptr); LOG_DATA_32_BYTE_3(ptr)
#define LOG_DATA_128_BYTE_3(ptr)		LOG_DATA_64_BYTE_3(ptr); LOG_DATA_64_BYTE_3(ptr)
#define LOG_DATA_256_BYTE_3(ptr)		LOG_DATA_128_BYTE_3(ptr);LOG_DATA_128_BYTE_3(ptr)
#define LOG_DATA_512_BYTE_3(ptr)		LOG_DATA_256_BYTE_3(ptr);LOG_DATA_256_BYTE_3(ptr)
#define LOG_DATA_768_BYTE_3(ptr)		LOG_DATA_512_BYTE_3(ptr);LOG_DATA_256_BYTE_3(ptr)
#define LOG_DATA_1K_BYTE_3(ptr)			LOG_DATA_512_BYTE_3(ptr);LOG_DATA_512_BYTE_3(ptr)
#define LOG_DATA_2K_BYTE_3(ptr)			LOG_DATA_1K_BYTE_3(ptr); LOG_DATA_1K_BYTE_3(ptr)
#define LOG_DATA_3K_BYTE_3(ptr)			LOG_DATA_2K_BYTE_3(ptr); LOG_DATA_1K_BYTE_3(ptr)
#define LOG_DATA_3_8K_BYTE_3(ptr)		LOG_DATA_3K_BYTE_3(ptr); LOG_DATA_768_BYTE_3(ptr)
#define LOG_DATA_4K_BYTE_3(ptr)			LOG_DATA_2K_BYTE_3(ptr); LOG_DATA_2K_BYTE_3(ptr)
#define LOG_DATA_8K_BYTE_3(ptr)			LOG_DATA_4K_BYTE_3(ptr); LOG_DATA_4K_BYTE_3(ptr)
#define LOG_DATA_16K_BYTE_3(ptr)		LOG_DATA_8K_BYTE_3(ptr); LOG_DATA_8K_BYTE_3(ptr)
#define LOG_DATA_24K_BYTE_3(ptr)		LOG_DATA_16K_BYTE_3(ptr); LOG_DATA_8K_BYTE_3(ptr)
#define LOG_DATA_28K_BYTE_3(ptr)		LOG_DATA_24K_BYTE_3(ptr);LOG_DATA_4K_BYTE_3(ptr)
#define LOG_DATA_30K_BYTE_3(ptr)		LOG_DATA_28K_BYTE_3(ptr);LOG_DATA_2K_BYTE_3(ptr)
#define LOG_DATA_31K_BYTE_3(ptr)		LOG_DATA_30K_BYTE_3(ptr);LOG_DATA_1K_BYTE_3(ptr)
//#define LOG_DATA_32K_BYTE_3(ptr)		LOG_DATA_16K_BYTE_3(ptr);LOG_DATA_16K_BYTE_3(ptr)

//**********************************************************
//			Faster Logging Function
//**********************************************************

#define LOG_DATA_2_BYTE_4(ptr)			LOG_DATA_1_BYTE_4_CYCLE(ptr);  LOG_DATA_1_BYTE_4_CYCLE(ptr)
#define LOG_DATA_4_BYTE_4(ptr)			LOG_DATA_2_BYTE_4(ptr);  LOG_DATA_2_BYTE_4(ptr)
#define LOG_DATA_8_BYTE_4(ptr)			LOG_DATA_4_BYTE_4(ptr);  LOG_DATA_4_BYTE_4(ptr)
#define LOG_DATA_16_BYTE_4(ptr)			LOG_DATA_8_BYTE_4(ptr);  LOG_DATA_8_BYTE_4(ptr)
#define LOG_DATA_32_BYTE_4(ptr)			LOG_DATA_16_BYTE_4(ptr); LOG_DATA_16_BYTE_4(ptr)
#define LOG_DATA_64_BYTE_4(ptr)			LOG_DATA_32_BYTE_4(ptr); LOG_DATA_32_BYTE_4(ptr)
#define LOG_DATA_128_BYTE_4(ptr)		LOG_DATA_64_BYTE_4(ptr); LOG_DATA_64_BYTE_4(ptr)
#define LOG_DATA_256_BYTE_4(ptr)		LOG_DATA_128_BYTE_4(ptr);LOG_DATA_128_BYTE_4(ptr)
#define LOG_DATA_512_BYTE_4(ptr)		LOG_DATA_256_BYTE_4(ptr);LOG_DATA_256_BYTE_4(ptr)
#define LOG_DATA_768_BYTE_4(ptr)		LOG_DATA_512_BYTE_4(ptr);LOG_DATA_256_BYTE_4(ptr)
#define LOG_DATA_1K_BYTE_4(ptr)			LOG_DATA_512_BYTE_4(ptr);LOG_DATA_512_BYTE_4(ptr)
#define LOG_DATA_3K_BYTE_4(ptr)			LOG_DATA_1K_BYTE_4(ptr); LOG_DATA_1K_BYTE_4(ptr); LOG_DATA_1K_BYTE_4(ptr)
#define LOG_DATA_3_8K_BYTE_4(ptr)		LOG_DATA_3K_BYTE_4(ptr); LOG_DATA_768_BYTE_4(ptr)








